
-- TODO: localize


BINDING_HEADER_PANOSHOT = "PanoShot";
BINDING_NAME_PANOSHOT_ONESHOT = "Take one screenshot (hide UI)"
BINDING_NAME_PANOSHOT_PANOSHOT = "Take multiple screenshots (hide UI)"

SLASH_PANOSHOTONCE1 = "/oneshot";
SLASH_PANOSHOT1 = "/panoshot";

--

local rate = 24;
local OPTIONS_FARCLIP_MAX = 1277

local pframe;
local cvars_saved = {}
local cvars = {
    farclip = OPTIONS_FARCLIP_MAX,
    UnitNameEnemyGuardianName = 0,
    UnitNameEnemyPetName = 0,
    UnitNameEnemyPlayerName = 0,
    UnitNameEnemyTotemName = 0,
    UnitNameFriendlyGuardianName = 0,
    UnitNameFriendlyPetName = 0,
    UnitNameFriendlyPlayerName = 0,
    UnitNameFriendlySpecialNPCName = 0,
    UnitNameFriendlyTotemName = 0,
    UnitNameHostleNPC = 0,
    UnitNameGuildTitle = 0,
    UnitNameNonCombatCreatureName = 0,
    UnitNameNPC = 0,
    UnitNameOwn = 0,
    UnitNamePlayerGuild = 0,
    UnitNamePlayerPVPTitle = 0,
};

--
--

PanoShot = {}
local PanoShot = PanoShot

--
--

local function hideui()
    UIParent:Hide();
    ActionStatus:UnregisterEvent("SCREENSHOT_SUCCEEDED");

    for h,v in pairs(cvars) do
        cvars_saved[h] = GetCVar(h);
        SetCVar(h, v);
    end
end

local function showui()
    UIParent:Show();
    ActionStatus:RegisterEvent("SCREENSHOT_SUCCEEDED");

    for h,v in pairs(cvars_saved) do
        SetCVar(h, cvars_saved[h]);
    end
end

local curp = 0;
local state, onlyonce
local setcursor;
pframe = CreateFrame("Frame");
pframe:SetFrameStrata("FULLSCREEN");
pframe:SetParent(WorldFrame);
pframe:SetAllPoints();
pframe:RegisterEvent("SCREENSHOT_SUCCEEDED");
pframe:RegisterEvent("SCREENSHOT_FAILED");
pframe:EnableMouse(1);
pframe:Hide();

PanoShot.mouse_frame = pframe

pframe:SetScript("OnEvent", function(self, event)
    if event == "SCREENSHOT_SUCCEEDED" then
        if state == "WAITING" then
            curp = curp + rate
            FlipCameraYaw(rate)
            state = "RUNNING"
        end
    elseif event == "SCREENSHOT_FAILED" then
        if state ~= nil then
            state = "ENDING"
            print("PanoShot: Got SCREENSHOT_FAILED")
        end
    end
end)

pframe:SetScript("OnUpdate", function()
    if state == nil then
        SetCursor("Interface\\AddOns\\PanoShot\\NilCursor")
        state = "RUNNING"
    elseif state == "RUNNING" then
        if curp >= 360 or onlyonce then
            state = "ENDING"
        else
            state = "WAITING"
        end
        
        SetCursor("Interface\\AddOns\\PanoShot\\NilCursor")
        TakeScreenshot()
    elseif state == "ENDING" then
        PanoShot.Stop()
    end
end);

---
---

function PanoShot.IsRunning()
    return pframe:IsShown();
end

function PanoShot.Start()
    if(not PanoShot.IsRunning()) then
        hideui();
        curp = 0;
        pframe:Show();
    end
end

function PanoShot.Stop()
    if(PanoShot.IsRunning()) then
        state = nil
        pframe:Hide();
        showui();
        if(not onlyonce) then
            FlipCameraYaw(-curp);
        end
        onlyonce = nil;
    end
end

function PanoShot.StartStop()
    if(not PanoShot.IsRunning()) then
        PanoShot.Start();
    else
        PanoShot.Stop();
    end
end

function PanoShot.Once()
    onlyonce = 1
    PanoShot.Start();
end

function SlashCmdList.PANOSHOT(s)
    PanoShot.StartStop()
end

function SlashCmdList.PANOSHOTONCE(s)
    PanoShot.Once()
end

